apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: {{ .Chart.Name }}
  labels:
    app: {{ .Chart.Name }}
spec:
  replicas: 1
  serviceName: {{ .Chart.Name }}
  selector:
    matchLabels:
      app: {{ .Chart.Name }}
  template:
    metadata:
      labels:
        app: {{ .Chart.Name }}
    spec:
      containers:
      - name: {{ .Chart.Name }}
        image: "{{ .Values.image.registry }}/{{ .Values.image.repository }}:{{ .Values.image.tag }}"
        imagePullPolicy: {{ .Values.imagePullPolicy }}
        {{- with .Values.command }}
        command:
          {{- toYaml . | nindent 10 }}
        {{- end }}
        {{- with .Values.args }}
        args:
          {{- toYaml . | nindent 10 }}
        {{- end }}
        {{- with .Values.env }}
        env: 
          {{- toYaml . | nindent 10}}
        {{- end }}
        envFrom: 
          - configMapRef:
              name: "{{ .Chart.Name }}-config"
        {{- with .Values.envFrom }}
          {{- toYaml . | nindent 10}}
        {{- end }}
        ports:
        - name: game
          containerPort: 8211
          protocol: UDP
        - name: query
          containerPort: 27015
          protocol: UDP
        - name: rcon
          containerPort: 25575
          protocol: TCP
        {{- with .Values.livenessProbe }}
        livenessProbe:
          {{- toYaml . | nindent 10 }}
        {{- end }}
        {{- with .Values.readinessProbe }}
        readinessProbe:
          {{- toYaml . | nindent 10 }}
        {{- end }}
        {{- with .Values.resources }}
        resources: 
          {{- toYaml . | nindent 10}}
        {{- end }}
        volumeMounts:
          - mountPath: /palworld
            name: datadir
          {{- with .Values.volumeMounts }}
            {{- toYaml . | nindent 10 }}
          {{- end }}
      {{- with .Values.volumes }}
      volumes:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ .Chart.Name }}
      {{- with .Values.securityContext }}
      securityContext:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      
  volumeClaimTemplates:
  - metadata:
      name: datadir
    spec:
      accessModes: {{ .Values.persistence.config.accessModes }}
      storageClassName: {{ .Values.persistence.config.storageClassName | quote }}
      resources:
        requests:
          storage: {{ .Values.persistence.config.size | quote }}
